Index: trunk/gui/scripts/mainwin.tcl
===================================================================
--- trunk/gui/scripts/mainwin.tcl	(revision 6716)
+++ trunk/gui/scripts/mainwin.tcl	(revision 1)
@@ -1,3 +1,2 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: mainwin - main application window for Rappture
@@ -10,11 +9,7 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
-#
-#  See the file "license.terms" for information on usage and
-#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+#  Copyright (c) 2004  Purdue Research Foundation, West Lafayette, IN
 # ======================================================================
 package require Itk
-package require BLT
 
 option add *MainWin.mode desktop widgetDefault
@@ -23,51 +18,6 @@
 option add *MainWin.anchor center widgetDefault
 option add *MainWin.titleFont \
-    -*-helvetica-bold-o-normal-*-14-* widgetDefault
-
-#
-# Tk text widget doesn't honor Ctrl-V by default.  Get rid
-# of the default binding so that Ctrl-V works for <<Paste>>
-# as expected.
-#
-bind Text <Control-KeyPress-v> {}
-
-#
-# Fix the built-in <<Paste>> bindings to work properly even
-# for the X11 windowing system.  By default, Tk won't replace
-# selected text in X11.  What kind of stupid nonsense is that?
-#
-bind Entry <<Paste>> {
-    catch {
-        # always replace existing selection
-        catch { %W delete sel.first sel.last }
-
-        %W insert insert [::tk::GetSelection %W CLIPBOARD]
-        tk::EntrySeeInsert %W
-    }
-}
-proc ::tk_textPaste w {
-    global tcl_platform
-    if {![catch {::tk::GetSelection $w CLIPBOARD} sel]} {
-        if {[catch {$w cget -autoseparators} oldSeparator]} {
-            # in case we're using an older version of Tk
-            set oldSeparator 0
-        }
-        if { $oldSeparator } {
-            $w configure -autoseparators 0
-            $w edit separator
-        }
-
-        # always replace existing selection
-        catch { $w delete sel.first sel.last }
-        $w insert insert $sel
-
-        if { $oldSeparator } {
-            $w edit separator
-            $w configure -autoseparators 1
-        }
-    }
-}
-
-# ======================================================================
+    -*-helvetica-bold-o-normal-*-*-140-* widgetDefault
+
 itcl::class Rappture::MainWin {
     inherit itk::Toplevel
@@ -80,14 +30,12 @@
 
     public method draw {option args}
-    public method syncCutBuffer {option args}
 
     protected method _redraw {}
 
     private variable _contents ""  ;# frame containing app
-    private variable _sync         ;# to sync current selection and cut buffer
     private variable _bgscript ""  ;# script of background drawing cmds
     private variable _bgparser ""  ;# parser for bgscript
 }
-
+                                                                                
 itk::usual MainWin {
     keep -background -cursor foreground -font
@@ -127,5 +75,5 @@
         -menu $itk_component(filemenu)
     $itk_component(filemenu) add command -label "Exit" -underline 1 \
-        -command {destroy .}
+        -command exit
 
     #
@@ -147,105 +95,4 @@
     set btags [bindtags $itk_component(hull)]
     bindtags $itk_component(hull) [lappend btags RapptureMainWin]
-
-    set _sync(cutbuffer) ""
-    set _sync(selection) ""
-
-    #
-    # We used to do this to make "copy/paste with desktop" work
-    # properly.  Well, it never really worked *properly*, but
-    # it was an attempt.  We might as well skip it.  We use
-    # the importfile/exportfile stuff now.
-    #
-    ##global tcl_platform
-    ##if {$tcl_platform(platform) == "unix"} {
-    ##    # this sync stuff works only for X windows
-    ##    blt::cutbuffer set ""
-    ##    syncCutBuffer ifneeded
-    ##}
-}
-
-# ----------------------------------------------------------------------
-# USAGE: syncCutBuffer ifneeded
-# USAGE: syncCutBuffer transfer <offset> <maxchars>
-# USAGE: syncCutBuffer lostselection
-#
-# Invoked automatically whenever the mouse pointer enters or leaves
-# a main window to sync the cut buffer with the primary selection.
-# This helps applications work properly with the "Copy/Paste with
-# Desktop" option on the VNC applet for the nanoHUB.
-#
-# The "ifneeded" option syncs the cutbuffer and the primary selection
-# if either one has new data.
-#
-# The "fromselection" option syncs from the primary selection to the
-# cut buffer.  If there's a primary selection, it gets copied to the
-# cut buffer.
-# ----------------------------------------------------------------------
-itcl::body Rappture::MainWin::syncCutBuffer {option args} {
-    set mainwin $itk_component(hull)
-    switch -- $option {
-        ifneeded {
-            #
-            # See if the incoming cut buffer has changed.
-            # If so, then sync the new input to the primary selection.
-            #
-            set s [blt::cutbuffer get]
-            if {"" != $s && ![string equal $s $_sync(cutbuffer)]} {
-                #
-                # Convert any \r's in the cutbuffer to \n's.
-                #
-                if {[string first "\r" $s] >= 0} {
-                    regsub -all "\r\n" $s "\n" s
-                    regsub -all "\r" $s "\n" s
-                    blt::cutbuffer set $s
-                }
-
-                set _sync(cutbuffer) $s
-
-                if {![string equal $s $_sync(selection)]
-                      && [selection own -selection PRIMARY] != $mainwin} {
-                    set _sync(selection) $s
-
-                    clipboard clear
-                    clipboard append -- $s
-                    selection handle -selection PRIMARY $mainwin \
-                        [itcl::code $this syncCutBuffer transfer]
-                    selection own -selection PRIMARY -command \
-                        [itcl::code $this syncCutBuffer lostselection] \
-                        $mainwin
-                }
-            }
-
-            #
-            # See if the selection has changed.  If so, then sync
-            # the new input to the cut buffer, so it's available
-            # outside the VNC client.
-            #
-            if {[catch {selection get -selection PRIMARY} s]} {
-                set s ""
-            }
-            if {"" != $s && ![string equal $s $_sync(selection)]} {
-                set _sync(selection) $s
-                blt::cutbuffer set $s
-            }
-
-            # do this again soon
-            after 1000 [itcl::code $this syncCutBuffer ifneeded]
-        }
-        transfer {
-            if {[llength $args] != 2} {
-                error "wrong # args: should be \"syncCutBuffer transfer offset max\""
-            }
-            set offset [lindex $args 0]
-            set maxchars [lindex $args 1]
-            return [string range $_currseln $offset [expr {$offset+$maxchars-1}]]
-        }
-        lostselection {
-            # nothing to do
-        }
-        default {
-            error "bad option \"$option\": should be ifneeded, transfer, or lostselection"
-        }
-    }
 }
 
@@ -279,5 +126,4 @@
         }
 
-        set bd 0  ;# optional border
         set sw [winfo width $itk_component(area)]
         set sh [winfo height $itk_component(area)]
@@ -286,54 +132,73 @@
         set w [winfo reqwidth $itk_component(app)]
         set h [winfo reqheight $itk_component(app)]
-        if {$w > $sw-2*$bd} {
-            set $w [expr {$sw-2*$bd}]
+        if {$w > $sw} {
+            set $w $sw
             set clip 1
         }
 
-        set anchor $itk_option(-anchor)
+        set titleh 0
+        set fnt [option get $itk_component(hull) titleFont Font]
+        if {$itk_option(-title) != "" && $fnt != ""} {
+            set titleh [expr {[font metrics $fnt -linespace]+2}]
+        }
+        if {$h+$titleh > $sh} {
+            set $h [expr {$sh-$titleh}]
+            set clip 1
+        }
+
         switch -- $itk_option(-anchor) {
             n {
                 set x [expr {$sw/2}]
-                set y $bd
+                set y $titleh
+                set tx [expr {$x-$w/2}]
+                set ty $titleh
             }
             s {
                 set x [expr {$sw/2}]
-                set y [expr {$sh-$bd}]
+                set y $sh
+                set tx [expr {$x-$w/2}]
+                set ty [expr {$sh-$h}]
             }
             center {
                 set x [expr {$sw/2}]
                 set y [expr {$sh/2}]
+                set tx [expr {$x-$w/2}]
+                set ty [expr {$y-$h/2}]
             }
             w {
-                set x $bd
+                set x 0
                 set y [expr {$sh/2}]
+                set tx 0
+                set ty [expr {$y-$h/2}]
             }
             e {
-                set x [expr {$sw-$bd}]
+                set x $sw
                 set y [expr {$sh/2}]
+                set tx [expr {$sw-$w}]
+                set ty [expr {$y-$h/2}]
             }
             nw {
-                set x $bd
-                set y $bd
+                set x 0
+                set y $titleh
+                set tx 0
+                set ty $titleh
             }
             ne {
-                set x [expr {$sw-$bd}]
-                set y $bd
+                set x $sw
+                set y $titleh
+                set tx [expr {$sw-$w}]
+                set ty $titleh
             }
             sw {
-                set x $bd
-                set y [expr {$sh-$bd}]
+                set x 0
+                set y $sh
+                set tx 0
+                set ty [expr {$sh-$h}]
             }
             se {
-                set x [expr {$sw-$bd}]
-                set y [expr {$sh-$bd}]
-            }
-            fill {
-                set anchor nw
-                set x $bd
-                set y $bd
-                set w [expr {$sw-2*$bd}]
-                set h [expr {$sh-2*$bd}]
-                set clip 1
+                set x $sw
+                set y $sh
+                set tx [expr {$sw-$w}]
+                set ty [expr {$sh-$h}]
             }
         }
@@ -346,6 +211,11 @@
 
         $itk_component(area) create window $x $y \
-            -anchor $anchor -window $itk_component(app) \
+            -anchor $itk_option(-anchor) -window $itk_component(app) \
             -width $w -height $h
+
+        if {$itk_option(-title) != "" && $fnt != ""} {
+            $itk_component(area) create text $tx [expr {$ty-2}] \
+                -anchor sw -text $itk_option(-title) -font $fnt
+        }
     }
 }
@@ -386,5 +256,5 @@
 # ----------------------------------------------------------------------
 itcl::configbody Rappture::MainWin::anchor {
-    if {[lsearch {n s e w ne nw se sw center fill} $itk_option(-anchor)] < 0} {
+    if {[lsearch {n s e w ne nw se sw center} $itk_option(-anchor)] < 0} {
         error "bad anchor \"$itk_option(-anchor)\""
     }
Index: trunk/gui/scripts/notebook.tcl
===================================================================
--- trunk/gui/scripts/notebook.tcl	(revision 6716)
+++ trunk/gui/scripts/notebook.tcl	(revision 1)
@@ -1,3 +1,2 @@
-# -*- mode: tcl; indent-tabs-mode: nil -*-
 # ----------------------------------------------------------------------
 #  COMPONENT: notebook - series of pages, but only one packed at a time
@@ -9,8 +8,5 @@
 # ======================================================================
 #  AUTHOR:  Michael McLennan, Purdue University
-#  Copyright (c) 2004-2012  HUBzero Foundation, LLC
-#
-#  See the file "license.terms" for information on usage and
-#  redistribution of this file, and for a DISCLAIMER OF ALL WARRANTIES.
+#  Copyright (c) 2004  Purdue Research Foundation, West Lafayette, IN
 # ======================================================================
 package require Itk
@@ -37,10 +33,9 @@
 
     private variable _count 0       ;# counter for unique names
-    private variable _dispatcher "" ;# dispatcher for !events
     private variable _pages ""      ;# list of page frames
     private variable _name2page     ;# maps name => frame for page
     private variable _current ""    ;# page currently shown
 }
-
+                                                                                
 itk::usual Notebook {
     keep -background -cursor
@@ -52,10 +47,12 @@
 itcl::body Rappture::Notebook::constructor {args} {
     pack propagate $itk_component(hull) no
-
-    Rappture::dispatcher _dispatcher
-    $_dispatcher register !fixsize
-    $_dispatcher dispatch $this !fixsize "[itcl::code $this _fixSize]; list"
-
     eval itk_initialize $args
+}
+
+# ----------------------------------------------------------------------
+# DESTRUCTOR
+# ----------------------------------------------------------------------
+itcl::body Rappture::Notebook::destructor {} {
+    after cancel [itcl::code $this _fixSize]
 }
 
@@ -80,6 +77,8 @@
         set _name2page($name) $itk_component($pname)
 
-        bind $itk_component($pname) <Configure> \
-            [itcl::code $_dispatcher event -after 100 !fixsize]
+        bind $itk_component($pname) <Configure> [itcl::code $this _fixSize]
+
+        after cancel [itcl::code $this _fixSize]
+        after idle [itcl::code $this _fixSize]
 
         lappend rlist $itk_component($pname)
@@ -140,10 +139,10 @@
 
 # ----------------------------------------------------------------------
-# USAGE: current ?<name>|next>|<back?
+# USAGE: current ?<name>|next>>|<<prev?
 #
 # Used to query/set the current page in the notebook.  With no args,
 # it returns the name of the current page.  Otherwise, it sets the
-# current page.  The special token "next>" is used to set the notebook
-# to the next logical page, and "<back" sets to the previous.
+# current page.  The special token "next>>" is used to set the notebook
+# to the next logical page, and "<<prev" sets to the previous.
 # ----------------------------------------------------------------------
 itcl::body Rappture::Notebook::current {args} {
@@ -155,5 +154,5 @@
             set name [lindex $args 0]
             set index 0
-            if {$name == "next>"} {
+            if {$name == "next>>"} {
                 if {$_current == ""} {
                     set index 0
@@ -165,5 +164,5 @@
                     }
                 }
-            } elseif {$name == "<back"} {
+            } elseif {$name == "<<prev"} {
                 if {$_current == ""} {
                     set index end
@@ -190,5 +189,5 @@
         }
         default {
-            error "wrong # args: should be \"current name|next>|<back\""
+            error "wrong # args: should be \"current name|next>>|<<prev\""
         }
     }
@@ -231,5 +230,6 @@
 # ----------------------------------------------------------------------
 itcl::configbody Rappture::Notebook::width {
-    $_dispatcher event -idle !fixsize
+    after cancel [itcl::code $this _fixSize]
+    after idle [itcl::code $this _fixSize]
 }
 
@@ -238,4 +238,5 @@
 # ----------------------------------------------------------------------
 itcl::configbody Rappture::Notebook::height {
-    $_dispatcher event -idle !fixsize
-}
+    after cancel [itcl::code $this _fixSize]
+    after idle [itcl::code $this _fixSize]
+}
